from typing import Any, Dict, List, Type, TypeVar, Union

from attrs import define, field

from ..types import UNSET, Unset

T = TypeVar("T", bound="MeasurementsResponse200ResponseResultItem")


@define
class MeasurementsResponse200ResponseResultItem:
    """
    Attributes:
        measurement (Union[Unset, str]):
    """

    measurement: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        measurement = self.measurement

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if measurement is not UNSET:
            field_dict[".measurement"] = measurement

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        measurement = d.pop(".measurement", UNSET)

        measurements_response_200_response_result_item = cls(
            measurement=measurement,
        )

        measurements_response_200_response_result_item.additional_properties = d
        return measurements_response_200_response_result_item

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
